# coding: utf-8

"""
    VRt.Routing [RO]

    # Description  **VRt.Routing** is designed to find a route between locations and build time-distance matrices.  ## Features  * Getting the distance and time between two locations, including traffic jams * Finding a route between specified locations * Creating a time-distance matrix  ## Entity relationship diagram  ![erd](../uml/routing.svg) 

    The version of the OpenAPI document: 6.20.2252
    Contact: servicedesk@veeroute.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json





class GeoSettings(BaseModel):
    """
    Geodata usage settings.   # noqa: E501
    """
    geo_provider: Optional[Annotated[str, Field(min_length=1, strict=True, max_length=256)]] = Field(default='OSRM', description="Geodata provider.")
    toll_roads: Optional[StrictBool] = Field(default=True, description="Use toll roads.")
    ferry_crossing: Optional[StrictBool] = Field(default=True, description="Use ferry crossing.")
    traffic_jams: Optional[StrictBool] = Field(default=True, description="Accounting for traffic during the route planning.")
    flight_distance: Optional[StrictBool] = Field(default=False, description="Use for calculating straight line distances. If `false` is specified, distances are calculated by roads. When this parameter is enabled, geo-provider not used and traffic (`traffic_jams`) is automatically disabled. ")
    restricted_zones: Optional[Annotated[List[Annotated[str, Field(min_length=1, strict=True, max_length=256)]], Field(min_length=0, max_length=5)]] = Field(default=None, description="List of restricted zones. ")
    __properties = ["geo_provider", "toll_roads", "ferry_crossing", "traffic_jams", "flight_distance", "restricted_zones"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GeoSettings:
        """Create an instance of GeoSettings from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GeoSettings:
        """Create an instance of GeoSettings from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return GeoSettings.parse_obj(obj)

        _obj = GeoSettings.parse_obj({
            "geo_provider": obj.get("geo_provider") if obj.get("geo_provider") is not None else 'OSRM',
            "toll_roads": obj.get("toll_roads") if obj.get("toll_roads") is not None else True,
            "ferry_crossing": obj.get("ferry_crossing") if obj.get("ferry_crossing") is not None else True,
            "traffic_jams": obj.get("traffic_jams") if obj.get("traffic_jams") is not None else True,
            "flight_distance": obj.get("flight_distance") if obj.get("flight_distance") is not None else False,
            "restricted_zones": obj.get("restricted_zones")
        })
        return _obj


